<?php

require_once('config.php');
require_once('moz_api.php');
require_once('crawl_lib.php');
require_once('social_lib.php');
require_once('output_lib.php');

$target_urls = array();
$crawl_urls = array();
$authored_urls = array();
$authors = array();

for ($i=1; $i < $argc; $i++)
{
	$target_urls[] = $argv[$i];
}

// Main loop - loops over each of the target URLs
// gathers the back links, and adds them to the crawl list.
foreach($target_urls as $target_url)
{
	$backlinks_for_target = array();
	
	//Somewhat naive - as the URLs could have that as parameter later, but unlikely. Will do for now. :)
	$target_url = str_ireplace("http://", "", $target_url);
	$target_url = str_ireplace("https://", "", $target_url);
	
	echo "Acquiring backlinks for $target_url.. ";
	
	if (count($target_urls) > 1)
		sleep($rate_throttle);
		
	// change true to false
	$backlinks_for_target = fetch_backlinks($target_url, $get_no_follows, $domain_links);
	
	echo "Found " . count($backlinks_for_target) . "\n";
	
	// Add details to the crawl URLs list.
	// Not the speediest method, but fast enough.
	foreach($backlinks_for_target as $this_backlink)
	{
		$crawl_urls[$this_backlink['uu']] = array();
		$crawl_urls[$this_backlink['uu']]['ut'] = round($this_backlink['ut'], 2);
		$crawl_urls[$this_backlink['uu']]['upa'] = round($this_backlink['upa'], 2);
		$crawl_urls[$this_backlink['uu']]['pda'] = round($this_backlink['pda'], 2);
		
		if (!array_key_exists('targets', $crawl_urls[$this_backlink['uu']]))
			$crawl_urls[$this_backlink['uu']]['targets'] = array();
			
		$crawl_urls[$this_backlink['uu']]['targets'] = $target_url;
	}
	
}

echo "\nIdentified " . count($crawl_urls) . " URLs to crawl.\n\n";

echo "Crawling URLs: \n\n";

$i = 1;
$num_urls = count($crawl_urls);
foreach($crawl_urls as $this_url=>$url_details_array)
{	
	echo "\n" . $i . " of " . $num_urls . "\n";
	if ($author_id = get_page_author_id($this_url))
	{
		$authored_urls[$this_url] = $url_details_array;
		$authored_urls[$this_url]['author'] = $author_id;
		
		if (!array_key_exists($author_id, $authors))
		{
			$authors[$author_id] = array();
			$authors[$author_id]['links'] = array();
		}
		
		//echo " $author_id => " . $this_url . "\n";
		$authors[$author_id]['links'][] = $this_url;
	}
	$i++;
}

echo "\n";
echo "\nIdentified " . count($authored_urls) . " authored URLs from " . count($authors) . " authors.\n\n";

echo "Downloading author details.\n";

echo "\nAuthors:\n\n";

foreach($authors as $author_id=>$author_details)
{
	sleep(5); // don't annoy the servers.
	$authors[$author_id] = array_merge($authors[$author_id], get_author_details_via_api($author_id));
	$authors[$author_id] =  array_merge($authors[$author_id], get_author_details_via_scrape($author_id));
	$authors[$author_id] =  array_merge($authors[$author_id], get_author_twitter_details($authors[$author_id]));

	output_author($author_id, $authors[$author_id]);
}
foreach($authors as $author_id=>$author_details)
{
	//echo $authors[$author_id]['displayName'] . " linked to: \n";
	
	$authors[$author_id]['targets'] = array();
	
	foreach ($authors[$author_id]['links'] as $linked_to_url)
	{
		$authors[$author_id]['targets'][$crawl_urls[$linked_to_url]['targets']] = $crawl_urls[$linked_to_url]['targets'];
	}
}

$report_filename = "report_" . date('Y-m-d-h-i-s') . ".html";
echo "Writing report " . $report_filename . ".\n";

write_multiple_url_report($report_filename, $authors, $target_urls)



?>