<?php

	// This function outputs the author information to the screen.
	// Primarily used for debugging.
	function output_author($author_id, $author)
	{
		echo "\n==== " . $author['displayName'] . " ==== \n";
		echo "Profile: https://plus.google.com/" . $author_id . "\n";
		echo "Image: " . $author['image']['url'] . "\n";
		echo "Twitter handle: " . $author['twitter_screename'] . "\n";
		echo "Circle count: " . $author['in_circles'] . "\n";
		echo "Follower count: " . $author['twitter_follower_count'] . "\n";
		
		echo "Contributes to: \n";
		
		foreach($author['contributes_to_urls'] as $url)
		{
			echo "   " . $url . "\n";
		}
		
		echo "\n\n";
	}
	
	function write_single_url_report($report_filename, $authored_urls, $authors, $target_url)
	{			
		$output = "";
		foreach($authored_urls as $authored_url=>$authored_url_details)
		{
			$author = $authors[$authored_url_details['author']];
			
			$output .= "<tr>\n<td>\n";
			
			$output .= '<img src="' . $author['image']['url'] . '" /><br />' . "\n";
			
			$output .= $author['displayName'] . "<br />\n";
			
			
			$output .= '<small><a href="https://plus.google.com/' . $authored_url_details['author'] . '">Google+</a>';
			
			if ($author['twitter_screename'] != 'unknown')
				$output .= '&nbsp;|&nbsp;<a href="http://twitter.com/' . $author['twitter_screename']  . '">Twitter</a>';
			
			$output .= '</small>' . "\n";
			
			
			$output .= "</td>\n";
			
			$output .= "<td>" . $author['in_circles'] . "</td>\n";
			
			
			$output .= "<td>";
				
			if ($author['twitter_follower_count'] != "unknown")
				$output .= $author['twitter_follower_count'];
				
			$output .= "</td>\n";
				
				
			
			$output .= "<td>\n";
			
			
				foreach($author['contributes_to_urls'] as $url)
				{
					$formatted_url = str_ireplace("http://", "", $url);
					$formatted_url = str_ireplace("https://", "", $formatted_url);
					$output .= '<a href="' . $url . '">' . $formatted_url . "</a><br />\n";
				}
			
			$output .= "</td>\n";
			
			
			$output .= "<td><a href='http://" . $authored_url . "'>" . $authored_url . "</a></td>\n";
			
			$output .= "<td>" . $authored_url_details['upa'] . "</td>\n";
			$output .= "<td>" . $authored_url_details['pda'] . "</td>\n";
			
			$output .= "</tr>\n";
		}
		
		$head = file_get_contents("report_head.html");
		$foot = file_get_contents("report_foot.html");
		
		$head = str_replace("TARGETURL", $target_url, $head);
		$head = str_replace("COUNTURLS", count($authored_urls), $head);
		$head = str_replace("COUNTAUTHORS", count($authors), $head);
		
		file_put_contents($report_filename, $head . $output . $foot);
	}


	function write_multiple_url_report($report_filename, $authors, $targets)
	{			
		$output = "";
		
		foreach($authors as $author)
		{
			
			$output .= "<tr>\n<td>\n";
			
			$output .= '<img src="' . $author['image']['url'] . '" /><br />' . "\n";
			
			$output .= $author['displayName'] . "<br />\n";
			
			
			$output .= '<small><a href="https://plus.google.com/' . $authored_url_details['author'] . '">Google+</a>';
			
			if ($author['twitter_screename'] != 'unknown')
				$output .= '&nbsp;|&nbsp;<a href="http://twitter.com/' . $author['twitter_screename']  . '">Twitter</a>';
			
			$output .= '</small>' . "\n";
			
			
			$output .= "</td>\n";
			
			$output .= "<td>" . $author['in_circles'] . "</td>\n";
			
			
			$output .= "<td>";
				
			if ($author['twitter_follower_count'] != "unknown")
				$output .= $author['twitter_follower_count'];
				
			$output .= "</td>\n";
				
				
			
			$output .= "<td>\n";
		
			foreach($author['contributes_to_urls'] as $url)
			{
				$formatted_url = str_ireplace("http://", "", $url);
				$formatted_url = str_ireplace("https://", "", $formatted_url);
				$output .= '<a href="' . $url . '">' . $formatted_url . "</a><br />\n";
			}
		
			
			$output .= "</td>\n";
			
			$target_count = 0;
			foreach($targets as $target)
			{	
				$author_linked = in_array($target, $author['targets']);
				
				$output .= "<td>\n";
				
				if ($author_linked)
				{
					$target_count++;
					$output .= "Yes";
				}else{
					$output .= "No";
				}
				
				$output .= "</td>\n";
				
			}
			
			$output .= "<td>\n" . $target_count . "</td>\n";
				
			$output .= "</tr>\n";
		}
		
		$table_headers = "";
		foreach($targets as $target)
		{
			$table_headers .= "<th>" . $target . "</th>";
		}
		
		$head = file_get_contents("multi_report_head.html");
		$foot = file_get_contents("multi_report_foot.html");
		
		$head = str_replace("TARGETURL", $targets[0], $head);
		$head = str_replace("COUNTAUTHORS", count($authors), $head);
		$head = str_replace("URLTABLEHEADERS", $table_headers, $head);
		//URLTABLEHEADERS
		
		file_put_contents($report_filename, $head . $output . $foot);
	}

	
?>